import Vue from 'vue'
import Vuex from 'vuex'
// import _ from 'lodash'
import axios from 'axios'

Vue.use(Vuex)

// function getRandomInt(min, max) {
//   min = Math.ceil(min)
//   max = Math.floor(max)
//   return Math.floor(Math.random() * (max - min + 1)) + min
// }

// var files = {
//   'test-1': {id: 0, title: 'test 1', contents: '= test 1', slug: 'test-1', tags: ['a']},
//   'test-2': {id: 1, title: 'test 2', contents: '= test 2', slug: 'test-2', tags: ['b']},
//   'test-3': {id: 2, title: 'test 3', contents: '= test 3', slug: 'test-3', tags: ['a','b']},
//   'test-4': {id: 3, title: 'test 4', contents: '= test 4', slug: 'test-4', tags: ['c']}
// }

export default new Vuex.Store({
  state: {
    errs: [],
    searchResults: [],
    query: null,
    file: null
  },
  mutations: {
    clearError(state) {
      state.errs = []
    },
    addError(state, err) {
      state.errs.push(err)
    },
    setResults(state, results) {
      state.searchResults = results
    },
    setQuery(state, query) {
      state.query = query
    },
    setFile(state, file) {
      state.file = file
    },
    setContent(state, content) {
      state.file.Content = content
    },
    setTags(state, tags) {
      state.file.Tags = tags
    }
  },
  actions: {
    newFile: function({commit}) {
      return new Promise((resolve, reject) => {
        axios.post('/v1/entries', {})
          .catch(err => {
            commit('addError', err)
            reject(err)
          })
          .then(res => {
            commit('setFile', res.data)
            resolve(res.data)
          })
      })
    },
    getFile: function({ commit }, slug) {
      if (slug)
        return axios.get('/v1/entries/'+slug)
          .catch(err => commit('addError', err))
          .then(res => {
            commit('setFile', res.data)
          })
    },
    updateSearch: function ({commit, state}) {
      return new Promise((resolve, reject) => {
        let query = state.query || ""
        axios.get('/v1/entries?query='+query)
          .catch(err => {
            state.addError(err)
            reject(err)
          })
          .then(res =>{
            commit('setResults', res.data)
            resolve(res.data)
          })
      })
    },
    saveFile: function({state}) {
      if (state.file)
        return axios.put('/v1/entries/'+state.file.Slug, state.file)
    },
    deleteBySlug: function({dispatch,commit}, slug) {
      axios.delete('/v1/entries/'+slug)
        .catch(err => {
          commit('addError', err)
        })
        .then(() => {
          dispatch('updateSearch')
        })
    }
  },
  modules: {
  }
})
